Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsAudio.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsAudio.cpp	(revision 46631)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsAudio.cpp	(revision 46634)
@@ -71,7 +71,7 @@
 
     /* Load audio data to page: */
-    mGbAudio->setChecked(audioData.m_fAudioEnabled);
-    mCbAudioDriver->setCurrentIndex(mCbAudioDriver->findText(gpConverter->toString(audioData.m_audioDriverType)));
-    mCbAudioController->setCurrentIndex(mCbAudioController->findText(gpConverter->toString(audioData.m_audioControllerType)));
+    m_pCheckBoxAudio->setChecked(audioData.m_fAudioEnabled);
+    m_pComboAudioDriver->setCurrentIndex(m_pComboAudioDriver->findText(gpConverter->toString(audioData.m_audioDriverType)));
+    m_pComboAudioController->setCurrentIndex(m_pComboAudioController->findText(gpConverter->toString(audioData.m_audioControllerType)));
 
     /* Polish page finally: */
@@ -87,7 +87,7 @@
 
     /* Gather audio data: */
-    audioData.m_fAudioEnabled = mGbAudio->isChecked();
-    audioData.m_audioDriverType = gpConverter->fromString<KAudioDriverType>(mCbAudioDriver->currentText());
-    audioData.m_audioControllerType = gpConverter->fromString<KAudioControllerType>(mCbAudioController->currentText());
+    audioData.m_fAudioEnabled = m_pCheckBoxAudio->isChecked();
+    audioData.m_audioDriverType = gpConverter->fromString<KAudioDriverType>(m_pComboAudioDriver->currentText());
+    audioData.m_audioControllerType = gpConverter->fromString<KAudioControllerType>(m_pComboAudioController->currentText());
 
     /* Cache audio data: */
@@ -128,7 +128,7 @@
 void UIMachineSettingsAudio::setOrderAfter (QWidget *aWidget)
 {
-    setTabOrder (aWidget, mGbAudio);
-    setTabOrder (mGbAudio, mCbAudioDriver);
-    setTabOrder (mCbAudioDriver, mCbAudioController);
+    setTabOrder (aWidget, m_pCheckBoxAudio);
+    setTabOrder (m_pCheckBoxAudio, m_pComboAudioDriver);
+    setTabOrder (m_pComboAudioDriver, m_pComboAudioController);
 }
 
@@ -144,51 +144,51 @@
 {
     /* Save the current selected value */
-    int currentDriver = mCbAudioDriver->currentIndex();
+    int currentDriver = m_pComboAudioDriver->currentIndex();
     /* Clear the driver box */
-    mCbAudioDriver->clear();
+    m_pComboAudioDriver->clear();
     /* Refill them */
-    mCbAudioDriver->addItem (gpConverter->toString (KAudioDriverType_Null));
+    m_pComboAudioDriver->addItem (gpConverter->toString (KAudioDriverType_Null));
 #if defined Q_WS_WIN32
-    mCbAudioDriver->addItem (gpConverter->toString (KAudioDriverType_DirectSound));
+    m_pComboAudioDriver->addItem (gpConverter->toString (KAudioDriverType_DirectSound));
 # ifdef VBOX_WITH_WINMM
-    mCbAudioDriver->addItem (gpConverter->toString (KAudioDriverType_WinMM));
+    m_pComboAudioDriver->addItem (gpConverter->toString (KAudioDriverType_WinMM));
 # endif
 #endif
 #if defined Q_OS_SOLARIS
-    mCbAudioDriver->addItem (gpConverter->toString (KAudioDriverType_SolAudio));
+    m_pComboAudioDriver->addItem (gpConverter->toString (KAudioDriverType_SolAudio));
 # if defined VBOX_WITH_SOLARIS_OSS
-    mCbAudioDriver->addItem (gpConverter->toString (KAudioDriverType_OSS));
+    m_pComboAudioDriver->addItem (gpConverter->toString (KAudioDriverType_OSS));
 #endif
 #endif
 #if defined Q_OS_LINUX || defined Q_OS_FREEBSD
-    mCbAudioDriver->addItem (gpConverter->toString (KAudioDriverType_OSS));
+    m_pComboAudioDriver->addItem (gpConverter->toString (KAudioDriverType_OSS));
 # ifdef VBOX_WITH_PULSE
-    mCbAudioDriver->addItem (gpConverter->toString (KAudioDriverType_Pulse));
+    m_pComboAudioDriver->addItem (gpConverter->toString (KAudioDriverType_Pulse));
 # endif
 #endif
 #if defined Q_OS_LINUX
 # ifdef VBOX_WITH_ALSA
-    mCbAudioDriver->addItem (gpConverter->toString (KAudioDriverType_ALSA));
+    m_pComboAudioDriver->addItem (gpConverter->toString (KAudioDriverType_ALSA));
 # endif
 #endif
 #if defined Q_OS_MACX
-    mCbAudioDriver->addItem (gpConverter->toString (KAudioDriverType_CoreAudio));
+    m_pComboAudioDriver->addItem (gpConverter->toString (KAudioDriverType_CoreAudio));
 #endif
     /* Set the old value */
-    mCbAudioDriver->setCurrentIndex (currentDriver);
+    m_pComboAudioDriver->setCurrentIndex (currentDriver);
 
     /* Save the current selected value */
-    int currentController = mCbAudioController->currentIndex();
+    int currentController = m_pComboAudioController->currentIndex();
     /* Clear the controller box */
-    mCbAudioController->clear();
+    m_pComboAudioController->clear();
     /* Refill them */
-    mCbAudioController->insertItem (mCbAudioController->count(),
+    m_pComboAudioController->insertItem (m_pComboAudioController->count(),
         gpConverter->toString (KAudioControllerType_HDA));
-    mCbAudioController->insertItem (mCbAudioController->count(),
+    m_pComboAudioController->insertItem (m_pComboAudioController->count(),
         gpConverter->toString (KAudioControllerType_AC97));
-    mCbAudioController->insertItem (mCbAudioController->count(),
+    m_pComboAudioController->insertItem (m_pComboAudioController->count(),
         gpConverter->toString (KAudioControllerType_SB16));
     /* Set the old value */
-    mCbAudioController->setCurrentIndex (currentController);
+    m_pComboAudioController->setCurrentIndex (currentController);
 }
 
@@ -196,5 +196,5 @@
 {
     m_pContainerAudioOptions->setEnabled(isMachineOffline());
-    mAudioChild->setEnabled(mGbAudio->isChecked());
-}
-
+    m_pContainerAudioSubOptions->setEnabled(m_pCheckBoxAudio->isChecked());
+}
+
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsAudio.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsAudio.ui	(revision 46631)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsAudio.ui	(revision 46634)
@@ -3,5 +3,5 @@
  VBox frontends: Qt4 GUI ("VirtualBox"):
 
- Copyright (C) 2008-2012 Oracle Corporation
+ Copyright (C) 2008-2013 Oracle Corporation
 
  This file is part of VirtualBox Open Source Edition (OSE), as
@@ -18,7 +18,7 @@
    <item>
     <widget class="QWidget" name="m_pContainerAudioOptions">
-     <layout class="QGridLayout">
+     <layout class="QGridLayout" name="m_pContainerLayoutAudioOptions">
       <item row="0" column="0" colspan="2">
-       <widget class="QCheckBox" name="mGbAudio">
+       <widget class="QCheckBox" name="m_pCheckBoxAudio">
         <property name="whatsThis">
          <string>When checked, a virtual PCI audio card will be plugged into the virtual machine and will communicate with the host audio system using the specified driver.</string>
@@ -46,11 +46,11 @@
       </item>
       <item row="1" column="1">
-       <widget class="QWidget" name="mAudioChild">
-        <layout class="QGridLayout">
+       <widget class="QWidget" name="m_pContainerAudioSubOptions">
+        <layout class="QGridLayout" name="m_pContainerLayoutAudioSubOptions">
          <property name="margin">
           <number>0</number>
          </property>
          <item row="0" column="0">
-          <widget class="QLabel" name="mLbAudioDriver">
+          <widget class="QLabel" name="m_pLabelAudioDriver">
            <property name="text">
             <string>Host Audio &amp;Driver:</string>
@@ -60,10 +60,10 @@
            </property>
            <property name="buddy">
-            <cstring>mCbAudioDriver</cstring>
+            <cstring>m_pComboAudioDriver</cstring>
            </property>
           </widget>
          </item>
          <item row="0" column="1">
-          <widget class="QComboBox" name="mCbAudioDriver">
+          <widget class="QComboBox" name="m_pComboAudioDriver">
            <property name="sizePolicy">
             <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">
@@ -78,5 +78,5 @@
          </item>
          <item row="1" column="0">
-          <widget class="QLabel" name="mLbAudioController">
+          <widget class="QLabel" name="m_pLabelAudioController">
            <property name="text">
             <string>Audio &amp;Controller:</string>
@@ -86,10 +86,10 @@
            </property>
            <property name="buddy">
-            <cstring>mCbAudioController</cstring>
+            <cstring>m_pComboAudioController</cstring>
            </property>
           </widget>
          </item>
          <item row="1" column="1">
-          <widget class="QComboBox" name="mCbAudioController">
+          <widget class="QComboBox" name="m_pComboAudioController">
            <property name="sizePolicy">
             <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">
@@ -127,7 +127,7 @@
  <connections>
   <connection>
-   <sender>mGbAudio</sender>
+   <sender>m_pCheckBoxAudio</sender>
    <signal>toggled(bool)</signal>
-   <receiver>mAudioChild</receiver>
+   <receiver>m_pContainerAudioSubOptions</receiver>
    <slot>setEnabled(bool)</slot>
   </connection>