Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp	(revision 46658)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp	(revision 46667)
@@ -2315,11 +2315,11 @@
         CHECK_ERROR_RET(machine, COMGETTER(VideoCaptureRate)(&Rate), rc);
         ULONG Fps;
-        CHECK_ERROR_RET(machine, COMGETTER(VideoCaptureFps)(&Fps), rc);
+        CHECK_ERROR_RET(machine, COMGETTER(VideoCaptureFPS)(&Fps), rc);
         Bstr File;
         CHECK_ERROR_RET(machine, COMGETTER(VideoCaptureFile)(File.asOutParam()), rc);
         if (details == VMINFO_MACHINEREADABLE)
         {
-            RTPrintf("VideoCaptureEnabled=\"%s\"\n", bActive ? "on" : "off");
-            RTPrintf("VideoCaptureScreens=");
+            RTPrintf("vcpenabled=\"%s\"\n", bActive ? "on" : "off");
+            RTPrintf("vcpscreens=");
             bool fComma = false;
             for (unsigned i = 0; i < screens.size(); i++)
@@ -2330,9 +2330,9 @@
                 }
             RTPrintf("\n");
-            RTPrintf("VideoCaptureWidth=%u\n", (unsigned)Width);
-            RTPrintf("VideoCaptureFile=\"%ls\"\n", File.raw());
-            RTPrintf("VideoCaptureHeight=%u\n", (unsigned)Height);
-            RTPrintf("VideoCaptureRate=%u\n", (unsigned)Rate);
-            RTPrintf("VideoCaptureFps=%u\n", (unsigned)Fps);
+            RTPrintf("vcpfile=\"%ls\"\n", File.raw());
+            RTPrintf("vcpwidth=%u\n", (unsigned)Width);
+            RTPrintf("vcpheight=%u\n", (unsigned)Height);
+            RTPrintf("vcprate=%u\n", (unsigned)Rate);
+            RTPrintf("vcpfps=%u\n", (unsigned)Fps);
         }
         else
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 46658)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 46667)
@@ -2517,5 +2517,5 @@
             case MODIFYVM_VCP_FPS:
             {
-                CHECK_ERROR(machine, COMSETTER(VideoCaptureFps)(ValueUnion.u32));
+                CHECK_ERROR(machine, COMSETTER(VideoCaptureFPS)(ValueUnion.u32));
                 break;
             }
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsDisplay.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsDisplay.cpp	(revision 46658)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsDisplay.cpp	(revision 46667)
@@ -119,5 +119,5 @@
     displayData.m_iVideoCaptureFrameWidth = m_machine.GetVideoCaptureWidth();
     displayData.m_iVideoCaptureFrameHeight = m_machine.GetVideoCaptureHeight();
-    displayData.m_iVideoCaptureFrameRate = m_machine.GetVideoCaptureFps();
+    displayData.m_iVideoCaptureFrameRate = m_machine.GetVideoCaptureFPS();
     displayData.m_iVideoCaptureBitRate = m_machine.GetVideoCaptureRate();
     displayData.m_screens = m_machine.GetVideoCaptureScreens();
@@ -275,5 +275,5 @@
                 m_machine.SetVideoCaptureWidth(displayData.m_iVideoCaptureFrameWidth);
                 m_machine.SetVideoCaptureHeight(displayData.m_iVideoCaptureFrameHeight);
-                m_machine.SetVideoCaptureFps(displayData.m_iVideoCaptureFrameRate);
+                m_machine.SetVideoCaptureFPS(displayData.m_iVideoCaptureFrameRate);
                 m_machine.SetVideoCaptureRate(displayData.m_iVideoCaptureBitRate);
                 m_machine.SetVideoCaptureScreens(displayData.m_screens);
@@ -290,5 +290,5 @@
             m_machine.SetVideoCaptureWidth(displayData.m_iVideoCaptureFrameWidth);
             m_machine.SetVideoCaptureHeight(displayData.m_iVideoCaptureFrameHeight);
-            m_machine.SetVideoCaptureFps(displayData.m_iVideoCaptureFrameRate);
+            m_machine.SetVideoCaptureFPS(displayData.m_iVideoCaptureFrameRate);
             m_machine.SetVideoCaptureRate(displayData.m_iVideoCaptureBitRate);
             m_machine.SetVideoCaptureScreens(displayData.m_screens);