Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 46677)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 46680)
@@ -250,11 +250,11 @@
 };
 
-class UIIndicatorNetworkAdapters : public QIStateIndicator
-{
-    Q_OBJECT;
-
-public:
-
-    UIIndicatorNetworkAdapters(CSession &session)
+class UIIndicatorNetwork : public QIStateIndicator
+{
+    Q_OBJECT;
+
+public:
+
+    UIIndicatorNetwork(CSession &session)
       : m_session(session)
       , m_pUpdateTimer(new QTimer(this))
@@ -356,11 +356,11 @@
 };
 
-class UIIndicatorUSBDevices : public QIStateIndicator
-{
-    Q_OBJECT;
-
-public:
-
-    UIIndicatorUSBDevices(CSession &session)
+class UIIndicatorUSB : public QIStateIndicator
+{
+    Q_OBJECT;
+
+public:
+
+    UIIndicatorUSB(CSession &session)
       : m_session(session)
     {
@@ -579,11 +579,11 @@
 };
 
-class UIIndicatorVirtualization : public QIStateIndicator
-{
-    Q_OBJECT;
-
-public:
-
-    UIIndicatorVirtualization(CSession &session)
+class UIIndicatorFeatures : public QIStateIndicator
+{
+    Q_OBJECT;
+
+public:
+
+    UIIndicatorFeatures(CSession &session)
       : m_session(session)
     {
@@ -705,11 +705,11 @@
 };
 
-class UIIndicatorHostkey : public QIStateIndicator
-{
-    Q_OBJECT;
-
-public:
-
-    UIIndicatorHostkey(CSession &session)
+class UIIndicatorKeyboard : public QIStateIndicator
+{
+    Q_OBJECT;
+
+public:
+
+    UIIndicatorKeyboard(CSession &session)
       : m_session(session)
     {
@@ -737,5 +737,5 @@
     : QObject(pParent)
     , m_session(session)
-    , m_pool(UIIndicatorIndex_End)
+    , m_pool(UIIndicatorIndex_Max)
 {
     /* Prepare: */
@@ -758,5 +758,5 @@
 {
     /* Populate indicator-pool: */
-    for (int iIndex = 0; iIndex < UIIndicatorIndex_End; ++iIndex)
+    for (int iIndex = 0; iIndex < UIIndicatorIndex_Max; ++iIndex)
     {
         /* Prepare indicator: */
@@ -764,14 +764,14 @@
         switch (index)
         {
-            case UIIndicatorIndex_HardDisks:       m_pool[index] = new UIIndicatorHardDisks(m_session); break;
-            case UIIndicatorIndex_OpticalDisks:    m_pool[index] = new UIIndicatorOpticalDisks(m_session); break;
-            case UIIndicatorIndex_FloppyDisks:     m_pool[index] = new UIIndicatorFloppyDisks(m_session); break;
-            case UIIndicatorIndex_NetworkAdapters: m_pool[index] = new UIIndicatorNetworkAdapters(m_session); break;
-            case UIIndicatorIndex_USBDevices:      m_pool[index] = new UIIndicatorUSBDevices(m_session); break;
-            case UIIndicatorIndex_SharedFolders:   m_pool[index] = new UIIndicatorSharedFolders(m_session); break;
-            case UIIndicatorIndex_VideoCapture:    m_pool[index] = new UIIndicatorVideoCapture(m_session); break;
-            case UIIndicatorIndex_Virtualization:  m_pool[index] = new UIIndicatorVirtualization(m_session); break;
-            case UIIndicatorIndex_Mouse:           m_pool[index] = new UIIndicatorMouse(m_session); break;
-            case UIIndicatorIndex_Hostkey:         m_pool[index] = new UIIndicatorHostkey(m_session); break;
+            case UIIndicatorIndex_HardDisks:     m_pool[index] = new UIIndicatorHardDisks(m_session); break;
+            case UIIndicatorIndex_OpticalDisks:  m_pool[index] = new UIIndicatorOpticalDisks(m_session); break;
+            case UIIndicatorIndex_FloppyDisks:   m_pool[index] = new UIIndicatorFloppyDisks(m_session); break;
+            case UIIndicatorIndex_Network:       m_pool[index] = new UIIndicatorNetwork(m_session); break;
+            case UIIndicatorIndex_USB:           m_pool[index] = new UIIndicatorUSB(m_session); break;
+            case UIIndicatorIndex_SharedFolders: m_pool[index] = new UIIndicatorSharedFolders(m_session); break;
+            case UIIndicatorIndex_VideoCapture:  m_pool[index] = new UIIndicatorVideoCapture(m_session); break;
+            case UIIndicatorIndex_Features:      m_pool[index] = new UIIndicatorFeatures(m_session); break;
+            case UIIndicatorIndex_Mouse:         m_pool[index] = new UIIndicatorMouse(m_session); break;
+            case UIIndicatorIndex_Keyboard:      m_pool[index] = new UIIndicatorKeyboard(m_session); break;
             default: break;
         }
@@ -782,5 +782,5 @@
 {
     /* Wipe-out indicator-pool: */
-    for (int iIndex = 0; iIndex < UIIndicatorIndex_End; ++iIndex)
+    for (int iIndex = 0; iIndex < UIIndicatorIndex_Max; ++iIndex)
     {
         /* Wipe-out indicator: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.h	(revision 46677)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.h	(revision 46680)
@@ -32,12 +32,12 @@
     UIIndicatorIndex_OpticalDisks,
     UIIndicatorIndex_FloppyDisks,
-    UIIndicatorIndex_NetworkAdapters,
-    UIIndicatorIndex_USBDevices,
+    UIIndicatorIndex_Network,
+    UIIndicatorIndex_USB,
     UIIndicatorIndex_SharedFolders,
     UIIndicatorIndex_VideoCapture,
-    UIIndicatorIndex_Virtualization,
+    UIIndicatorIndex_Features,
     UIIndicatorIndex_Mouse,
-    UIIndicatorIndex_Hostkey,
-    UIIndicatorIndex_End
+    UIIndicatorIndex_Keyboard,
+    UIIndicatorIndex_Max
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineDefs.h	(revision 46677)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineDefs.h	(revision 46680)
@@ -45,5 +45,5 @@
     UIVisualElement_SharedFolderStuff     = RT_BIT(8),
     UIVisualElement_VideoCapture          = RT_BIT(9),
-    UIVisualElement_VirtualizationStuff   = RT_BIT(10),
+    UIVisualElement_FeaturesStuff         = RT_BIT(10),
     UIVisualElement_MiniToolBar           = RT_BIT(11),
     UIVisualElement_AllStuff              = 0xFFFF
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 46677)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 46680)
@@ -61,5 +61,5 @@
 
     /* Update pause and virtualization stuff: */
-    updateAppearanceOf(UIVisualElement_PauseStuff | UIVisualElement_VirtualizationStuff);
+    updateAppearanceOf(UIVisualElement_PauseStuff | UIVisualElement_FeaturesStuff);
 }
 
@@ -109,15 +109,15 @@
 {
     /* Update virtualization stuff: */
-    updateAppearanceOf(UIVisualElement_VirtualizationStuff);
+    updateAppearanceOf(UIVisualElement_FeaturesStuff);
 }
 
 void UIMachineWindowNormal::sltUpdateIndicators()
 {
-    /* Update LEDs: */
+    /* Update indicators: */
     updateIndicatorState(indicatorsPool()->indicator(UIIndicatorIndex_HardDisks), KDeviceType_HardDisk);
     updateIndicatorState(indicatorsPool()->indicator(UIIndicatorIndex_OpticalDisks), KDeviceType_DVD);
     updateIndicatorState(indicatorsPool()->indicator(UIIndicatorIndex_FloppyDisks), KDeviceType_Floppy);
-    updateIndicatorState(indicatorsPool()->indicator(UIIndicatorIndex_USBDevices), KDeviceType_USB);
-    updateIndicatorState(indicatorsPool()->indicator(UIIndicatorIndex_NetworkAdapters), KDeviceType_Network);
+    updateIndicatorState(indicatorsPool()->indicator(UIIndicatorIndex_USB), KDeviceType_USB);
+    updateIndicatorState(indicatorsPool()->indicator(UIIndicatorIndex_Network), KDeviceType_Network);
     updateIndicatorState(indicatorsPool()->indicator(UIIndicatorIndex_SharedFolders), KDeviceType_SharedFolder);
 }
@@ -125,5 +125,5 @@
 void UIMachineWindowNormal::sltShowIndicatorsContextMenu(QIStateIndicator *pIndicator, QContextMenuEvent *pEvent)
 {
-    /* Show CD/DVD device LED context menu: */
+    /* Show optical-disks LED context menu: */
     if (pIndicator == indicatorsPool()->indicator(UIIndicatorIndex_OpticalDisks))
     {
@@ -131,5 +131,5 @@
             gActionPool->action(UIActionIndexRuntime_Menu_OpticalDevices)->menu()->exec(pEvent->globalPos());
     }
-    /* Show floppy drive LED context menu: */
+    /* Show floppy-disks LED context menu: */
     else if (pIndicator == indicatorsPool()->indicator(UIIndicatorIndex_FloppyDisks))
     {
@@ -137,12 +137,12 @@
             gActionPool->action(UIActionIndexRuntime_Menu_FloppyDevices)->menu()->exec(pEvent->globalPos());
     }
-    /* Show USB device LED context menu: */
-    else if (pIndicator == indicatorsPool()->indicator(UIIndicatorIndex_USBDevices))
+    /* Show usb LED context menu: */
+    else if (pIndicator == indicatorsPool()->indicator(UIIndicatorIndex_USB))
     {
         if (gActionPool->action(UIActionIndexRuntime_Menu_USBDevices)->isEnabled())
             gActionPool->action(UIActionIndexRuntime_Menu_USBDevices)->menu()->exec(pEvent->globalPos());
     }
-    /* Show network adapter LED context menu: */
-    else if (pIndicator == indicatorsPool()->indicator(UIIndicatorIndex_NetworkAdapters))
+    /* Show network LED context menu: */
+    else if (pIndicator == indicatorsPool()->indicator(UIIndicatorIndex_Network))
     {
         if (gActionPool->action(UIActionIndexRuntime_Menu_Network)->isEnabled())
@@ -171,5 +171,5 @@
 void UIMachineWindowNormal::sltProcessGlobalSettingChange(const char * /* aPublicName */, const char * /* aName */)
 {
-    /* Update host-combination LED: */
+    /* Update host-combination status-bar label: */
     m_pNameHostkey->setText(UIHostCombo::toReadableString(vboxGlobal().settings().hostCombo()));
 }
@@ -247,14 +247,14 @@
             this, SLOT(sltShowIndicatorsContextMenu(QIStateIndicator*, QContextMenuEvent*)));
 
-    /* USB Devices: */
-    QIStateIndicator *pLedUSBDevices = indicatorsPool()->indicator(UIIndicatorIndex_USBDevices);
-    pIndicatorBoxHLayout->addWidget(pLedUSBDevices);
-    connect(pLedUSBDevices, SIGNAL(contextMenuRequested(QIStateIndicator*, QContextMenuEvent*)),
+    /* USB: */
+    QIStateIndicator *pLedUSB = indicatorsPool()->indicator(UIIndicatorIndex_USB);
+    pIndicatorBoxHLayout->addWidget(pLedUSB);
+    connect(pLedUSB, SIGNAL(contextMenuRequested(QIStateIndicator*, QContextMenuEvent*)),
             this, SLOT(sltShowIndicatorsContextMenu(QIStateIndicator*, QContextMenuEvent*)));
 
-    /* Network Adapters: */
-    QIStateIndicator *pLedNetworkAdapters = indicatorsPool()->indicator(UIIndicatorIndex_NetworkAdapters);
-    pIndicatorBoxHLayout->addWidget(pLedNetworkAdapters);
-    connect(pLedNetworkAdapters, SIGNAL(contextMenuRequested(QIStateIndicator*, QContextMenuEvent*)),
+    /* Network: */
+    QIStateIndicator *pLedNetwork = indicatorsPool()->indicator(UIIndicatorIndex_Network);
+    pIndicatorBoxHLayout->addWidget(pLedNetwork);
+    connect(pLedNetwork, SIGNAL(contextMenuRequested(QIStateIndicator*, QContextMenuEvent*)),
             this, SLOT(sltShowIndicatorsContextMenu(QIStateIndicator*, QContextMenuEvent*)));
 
@@ -271,6 +271,6 @@
             this, SLOT(sltShowIndicatorsContextMenu(QIStateIndicator*, QContextMenuEvent*)));
 
-    /* Virtualization: */
-    pIndicatorBoxHLayout->addWidget(indicatorsPool()->indicator(UIIndicatorIndex_Virtualization));
+    /* Features: */
+    pIndicatorBoxHLayout->addWidget(indicatorsPool()->indicator(UIIndicatorIndex_Features));
 
     /* Separator: */
@@ -285,5 +285,5 @@
             this, SLOT(sltShowIndicatorsContextMenu(QIStateIndicator*, QContextMenuEvent*)));
 
-    /* Host Key: */
+    /* Keyboard: */
     m_pCntHostkey = new QWidget;
     QHBoxLayout *pHostkeyLedContainerLayout = new QHBoxLayout(m_pCntHostkey);
@@ -291,5 +291,5 @@
     pHostkeyLedContainerLayout->setSpacing(3);
     pIndicatorBoxHLayout->addWidget(m_pCntHostkey);
-    pHostkeyLedContainerLayout->addWidget(indicatorsPool()->indicator(UIIndicatorIndex_Hostkey));
+    pHostkeyLedContainerLayout->addWidget(indicatorsPool()->indicator(UIIndicatorIndex_Keyboard));
     m_pNameHostkey = new QLabel(UIHostCombo::toReadableString(vboxGlobal().settings().hostCombo()));
     pHostkeyLedContainerLayout->addWidget(m_pNameHostkey);
@@ -342,10 +342,10 @@
     UIMachineWindow::prepareHandlers();
 
-    /* Keyboard state-change updater: */
-    connect(machineLogic()->keyboardHandler(), SIGNAL(keyboardStateChanged(int)), indicatorsPool()->indicator(UIIndicatorIndex_Hostkey), SLOT(setState(int)));
-    /* Mouse state-change updater: */
+    /* Connect keyboard state-change handler: */
+    connect(machineLogic()->keyboardHandler(), SIGNAL(keyboardStateChanged(int)), indicatorsPool()->indicator(UIIndicatorIndex_Keyboard), SLOT(setState(int)));
+    /* Connect mouse state-change handler: */
     connect(machineLogic()->mouseHandler(), SIGNAL(mouseStateChanged(int)), indicatorsPool()->indicator(UIIndicatorIndex_Mouse), SLOT(setState(int)));
-    /* Early initialize required connections: */
-    indicatorsPool()->indicator(UIIndicatorIndex_Hostkey)->setState(machineLogic()->keyboardHandler()->keyboardState());
+    /* Early initialize created connections: */
+    indicatorsPool()->indicator(UIIndicatorIndex_Keyboard)->setState(machineLogic()->keyboardHandler()->keyboardState());
     indicatorsPool()->indicator(UIIndicatorIndex_Mouse)->setState(machineLogic()->mouseHandler()->mouseState());
 }
@@ -436,10 +436,10 @@
         {
             /* Hide USB menu: */
-            indicatorsPool()->indicator(UIIndicatorIndex_USBDevices)->setHidden(true);
+            indicatorsPool()->indicator(UIIndicatorIndex_USB)->setHidden(true);
         }
         else
         {
             /* Toggle USB LED: */
-            indicatorsPool()->indicator(UIIndicatorIndex_USBDevices)->setState(
+            indicatorsPool()->indicator(UIIndicatorIndex_USB)->setState(
                 usbController.GetEnabled() ? KDeviceActivity_Idle : KDeviceActivity_Null);
         }
@@ -572,14 +572,14 @@
         indicatorsPool()->indicator(UIIndicatorIndex_FloppyDisks)->updateAppearance();
     if (iElement & UIVisualElement_NetworkStuff)
-        indicatorsPool()->indicator(UIIndicatorIndex_NetworkAdapters)->updateAppearance();
+        indicatorsPool()->indicator(UIIndicatorIndex_Network)->updateAppearance();
     if (iElement & UIVisualElement_USBStuff &&
-        !indicatorsPool()->indicator(UIIndicatorIndex_USBDevices)->isHidden())
-        indicatorsPool()->indicator(UIIndicatorIndex_USBDevices)->updateAppearance();
+        !indicatorsPool()->indicator(UIIndicatorIndex_USB)->isHidden())
+        indicatorsPool()->indicator(UIIndicatorIndex_USB)->updateAppearance();
     if (iElement & UIVisualElement_SharedFolderStuff)
         indicatorsPool()->indicator(UIIndicatorIndex_SharedFolders)->updateAppearance();
     if (iElement & UIVisualElement_VideoCapture)
         indicatorsPool()->indicator(UIIndicatorIndex_VideoCapture)->updateAppearance();
-    if (iElement & UIVisualElement_VirtualizationStuff)
-        indicatorsPool()->indicator(UIIndicatorIndex_Virtualization)->updateAppearance();
+    if (iElement & UIVisualElement_FeaturesStuff)
+        indicatorsPool()->indicator(UIIndicatorIndex_Features)->updateAppearance();
 }
 