Index: trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 46760)
+++ trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 46761)
@@ -380,13 +380,13 @@
     switch (globalSettingsPageType)
     {
-        case GlobalSettingsPageType_General:   strResult = "General"; break;
-        case GlobalSettingsPageType_Input:     strResult = "Input"; break;
-        case GlobalSettingsPageType_Update:    strResult = "Update"; break;
-        case GlobalSettingsPageType_Language:  strResult = "Language"; break;
-        case GlobalSettingsPageType_Display:   strResult = "Display"; break;
-        case GlobalSettingsPageType_USB:       strResult = "USB"; break;
-        case GlobalSettingsPageType_Network:   strResult = "Network"; break;
-        case GlobalSettingsPageType_Extension: strResult = "Extension"; break;
-        case GlobalSettingsPageType_Proxy:     strResult = "Proxy"; break;
+        case GlobalSettingsPageType_General:    strResult = "General"; break;
+        case GlobalSettingsPageType_Input:      strResult = "Input"; break;
+        case GlobalSettingsPageType_Update:     strResult = "Update"; break;
+        case GlobalSettingsPageType_Language:   strResult = "Language"; break;
+        case GlobalSettingsPageType_Display:    strResult = "Display"; break;
+        case GlobalSettingsPageType_USB:        strResult = "USB"; break;
+        case GlobalSettingsPageType_Network:    strResult = "Network"; break;
+        case GlobalSettingsPageType_Extensions: strResult = "Extensions"; break;
+        case GlobalSettingsPageType_Proxy:      strResult = "Proxy"; break;
         default:
         {
@@ -404,13 +404,13 @@
      * to search through the keys using 'case-insensitive' rule: */
     QStringList keys;    QList<GlobalSettingsPageType> values;
-    keys << "General";   values << GlobalSettingsPageType_General;
-    keys << "Input";     values << GlobalSettingsPageType_Input;
-    keys << "Update";    values << GlobalSettingsPageType_Update;
-    keys << "Language";  values << GlobalSettingsPageType_Language;
-    keys << "Display";   values << GlobalSettingsPageType_Display;
-    keys << "USB";       values << GlobalSettingsPageType_USB;
-    keys << "Network";   values << GlobalSettingsPageType_Network;
-    keys << "Extension"; values << GlobalSettingsPageType_Extension;
-    keys << "Proxy";     values << GlobalSettingsPageType_Proxy;
+    keys << "General";    values << GlobalSettingsPageType_General;
+    keys << "Input";      values << GlobalSettingsPageType_Input;
+    keys << "Update";     values << GlobalSettingsPageType_Update;
+    keys << "Language";   values << GlobalSettingsPageType_Language;
+    keys << "Display";    values << GlobalSettingsPageType_Display;
+    keys << "USB";        values << GlobalSettingsPageType_USB;
+    keys << "Network";    values << GlobalSettingsPageType_Network;
+    keys << "Extensions"; values << GlobalSettingsPageType_Extensions;
+    keys << "Proxy";      values << GlobalSettingsPageType_Proxy;
     /* Invalid type for unknown words: */
     if (!keys.contains(strGlobalSettingsPageType, Qt::CaseInsensitive))
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.h	(revision 46760)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.h	(revision 46761)
@@ -253,5 +253,5 @@
     GlobalSettingsPageType_USB,
     GlobalSettingsPageType_Network,
-    GlobalSettingsPageType_Extension,
+    GlobalSettingsPageType_Extensions,
     GlobalSettingsPageType_Proxy,
     GlobalSettingsPageType_Max
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 46760)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 46761)
@@ -381,11 +381,11 @@
                     break;
                 }
-                /* Extension page: */
-                case GlobalSettingsPageType_Extension:
+                /* Extensions page: */
+                case GlobalSettingsPageType_Extensions:
                 {
                     pSettingsPage = new UIGlobalSettingsExtension;
                     addItem(":/extension_pack_32px.png", ":/extension_pack_disabled_32px.png",
                             ":/extension_pack_16px.png", ":/extension_pack_disabled_16px.png",
-                            iPageIndex, "#extension", pSettingsPage);
+                            iPageIndex, "#extensions", pSettingsPage);
                     break;
                 }
@@ -499,5 +499,5 @@
 
     /* Extension page: */
-    m_pSelector->setItemText(GlobalSettingsPageType_Extension, tr("Extensions"));
+    m_pSelector->setItemText(GlobalSettingsPageType_Extensions, tr("Extensions"));
 
     /* Proxy page: */